import os


import caffe
import numpy as np
import cv2
import sys
from PIL import Image

import time



def processImage(net ,IMAGE, outputName='out.jpg'):
	# load image, switch to BGR, subtract mean, and make dims C x H x W for Caffe
	#response = requests.get(IMAGE)
	#img = Image.open(BytesIO(response.content))
	img2 = Image.open(IMAGE)
	for imSz in [394]:
		img = img2.resize((imSz,imSz),Image.BICUBIC)
		in_ = np.array(img, dtype=np.float32)
		in_ = in_[:, :, ::-1]
		#in_ -= np.array((104.00698793, 116.66876762, 122.67891434))
		in_ = in_.transpose((2, 0, 1))

		#caffe.set_mode_cpu()
		# shape for input (data blob is N x C x H x W), set data
		net.blobs['data'].reshape(1, *in_.shape)
		net.blobs['data'].data[...] = in_
		# run net and take argmax for prediction
		time1 = time.time()
		net.forward()
		time2 = time.time()
		out = net.blobs['score_2classes'].data[0].argmax(axis=0)
		out = np.where(out > 0, 255, 0)
		result = Image.fromarray(out.astype(np.uint8))
		out = Image.merge('RGB',[Image.fromarray(out.astype(np.uint8)),Image.fromarray(out.astype(np.uint8)),Image.fromarray(out.astype(np.uint8))])
		res = Image.blend(img,out,0.5)
		res.save(format(imSz) +'_'+ outputName)
		print('function took '+format((time2-time1)*1000)+'ms')
	return result


if __name__ == '__main__':
	IMAGE = '1.png'
	OUTPUT = 'output.png'
	# load net

	net = caffe.Net('/home/alp/Workspace/Code/techloq-image-daemon/prototxt_folder/FCN_deploy_SKIN_394.prototxt',
					'/home/alp/Workspace/Data/Models/Skincolor_V_25/snapshot_iter_449800.caffemodel', caffe.TEST)
	image = processImage(net, IMAGE,OUTPUT)